unit MainFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Comms, StdCtrls, ExtCtrls;

type
  TMainForm = class(TForm)
    ComPort1: TComPort;
    ConnectButton: TButton;
    SettingsButton: TButton;
    OutMemo: TMemo;
    SendEdit: TEdit;
    SendButton: TButton;
    SendCheckBox: TCheckBox;
    SendBulkButton: TButton;
    WaitCheckBox: TCheckBox;
    WaitButton: TButton;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    CancelButton: TButton;
    procedure ConnectButtonClick(Sender: TObject);
    procedure SettingsButtonClick(Sender: TObject);
    procedure ComPort1RxChar(Sender: TObject; InQue: Integer);
    procedure SendButtonClick(Sender: TObject);
    procedure SendBulkButtonClick(Sender: TObject);
    procedure WaitButtonClick(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
    procedure ComPort1Open(Sender: TObject);
    procedure ComPort1Close(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.ConnectButtonClick(Sender: TObject);
begin
  if ComPort1.Connected then
    ComPort1.Close
  else
    ComPort1.Open;
end;

procedure TMainForm.SettingsButtonClick(Sender: TObject);
begin
  ComPort1.ShowPropForm;
end;

procedure TMainForm.ComPort1RxChar(Sender: TObject; InQue: Integer);
var
  Str: String;
begin
  ComPort1.ReadString(Str, InQue, True);
  OutMemo.Lines.Add(Str);
end;

procedure TMainForm.SendButtonClick(Sender: TObject);
var
  Str: String;
begin
  Str := SendEdit.Text;
  if SendCheckBox.Checked then
    Str := Str + #13#10;
  ComPort1.WriteString(Str, True);
end;

procedure TMainForm.SendBulkButtonClick(Sender: TObject);
var
  Buffer: Array[0..999] of char;
begin
  FillChar(Buffer, 1000, 65);
  ComPort1.Write(Buffer[0], 1000, WaitCheckBox.Checked);
end;

procedure TMainForm.WaitButtonClick(Sender: TObject);
begin
  ComPort1.WaitForLastIO;
end;

procedure TMainForm.CancelButtonClick(Sender: TObject);
begin
  ComPort1.AbortAllIO;
end;

procedure TMainForm.ComPort1Open(Sender: TObject);
begin
  ConnectButton.Caption := 'Close';
end;

procedure TMainForm.ComPort1Close(Sender: TObject);
begin
  ConnectButton.Caption := 'Open';
end;

end.
